import TransientDisposable from "./TransientDisposable";
import { CancelToken, IDisposable } from "./types";
/**
 * We recommend using CancelTokenFactory instead of using CancelToken directly.
 * This class will cancel previous token before creating new token for given key.
 */
export default class CancelTokenFactory extends TransientDisposable implements IDisposable {
    private mToken;
    /**
     * This will create a new token and cancel previous token
     */
    newToken(key?: string, timeout?: number): CancelToken;
    dispose(): void;
}
//# sourceMappingURL=CancelTokenFactory.d.ts.map