var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "../services/NavigationService", "./baseTypes"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var NavigationService_1 = require("../services/NavigationService");
    var baseTypes_1 = require("./baseTypes");
    /**
     * Reports an alert to user when an error has occurred
     * or validation has failed.
     * If you set success message, it will display an alert with success message.
     * If you set confirm message, it will ask form confirmation before executing this method.
     * You can configure options to enable/disable certain
     * alerts.
     * @param reportOptions
     */
    function Action(_a) {
        var _b = _a === void 0 ? {} : _a, _c = _b.success, success = _c === void 0 ? null : _c, _d = _b.successTitle, successTitle = _d === void 0 ? "Done" : _d, _e = _b.confirm, confirm = _e === void 0 ? null : _e, _f = _b.confirmTitle, confirmTitle = _f === void 0 ? null : _f, _g = _b.validate, validate = _g === void 0 ? false : _g, _h = _b.validateTitle, validateTitle = _h === void 0 ? null : _h;
        // tslint:disable-next-line: only-arrow-functions
        return function (target, key) {
            baseTypes_1.registerInit(target, function (vm) {
                // tslint:disable-next-line: ban-types
                var oldMethod = vm[key];
                var app = vm.app;
                // tslint:disable-next-line:only-arrow-functions
                vm[key] = function () {
                    var a = [];
                    for (var _i = 0; _i < arguments.length; _i++) {
                        a[_i] = arguments[_i];
                    }
                    return __awaiter(this, void 0, void 0, function () {
                        var ns, vMsg, pe, result, e_1;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    ns = app.resolve(NavigationService_1.NavigationService);
                                    _a.label = 1;
                                case 1:
                                    _a.trys.push([1, 10, , 12]);
                                    if (!validate) return [3 /*break*/, 3];
                                    if (!!vm.isValid) return [3 /*break*/, 3];
                                    vMsg = typeof validate === "boolean"
                                        ? "Please enter correct information"
                                        : validate;
                                    return [4 /*yield*/, ns.alert(vMsg, validateTitle || "Error")];
                                case 2:
                                    _a.sent();
                                    return [2 /*return*/];
                                case 3:
                                    if (!confirm) return [3 /*break*/, 5];
                                    return [4 /*yield*/, ns.confirm(confirm, confirmTitle || "Confirm")];
                                case 4:
                                    if (!(_a.sent())) {
                                        return [2 /*return*/];
                                    }
                                    _a.label = 5;
                                case 5:
                                    pe = oldMethod.apply(vm, a);
                                    if (!(pe && pe.then)) return [3 /*break*/, 9];
                                    return [4 /*yield*/, pe];
                                case 6:
                                    result = _a.sent();
                                    if (!success) return [3 /*break*/, 8];
                                    return [4 /*yield*/, ns.alert(success, successTitle)];
                                case 7:
                                    _a.sent();
                                    _a.label = 8;
                                case 8: return [2 /*return*/, result];
                                case 9: return [3 /*break*/, 12];
                                case 10:
                                    e_1 = _a.sent();
                                    if (/^(cancelled|canceled)$/i.test(e_1.toString().trim())) {
                                        // tslint:disable-next-line: no-console
                                        console.warn(e_1);
                                        return [2 /*return*/];
                                    }
                                    return [4 /*yield*/, ns.alert(e_1, "Error")];
                                case 11:
                                    _a.sent();
                                    return [3 /*break*/, 12];
                                case 12: return [2 /*return*/];
                            }
                        });
                    });
                };
            });
        };
    }
    exports.default = Action;
});
//# sourceMappingURL=Action.js.map